'
' Hersey Vector Font Object
' by Vincent DeCampo
'
' This library is released under the LGPL
'
/'

FONT DATA USE RESTRICTION:

	This distribution of the Hershey Fonts may be used by anyone for
	any purpose, commercial or otherwise, providing that:
		1. The following acknowledgements must be distributed with
			the font data:
			- The Hershey Fonts were originally created by Dr.
				A. V. Hershey while working at the U. S.
				National Bureau of Standards.
			- The format of the Font data in this distribution
				was originally created by
					James Hurt
					Cognition, Inc.
					900 Technology Park Drive
					Billerica, MA 01821
					(mit-eddie!ci-dandelion!hurt)
		2. The font data in this distribution may be converted into
			any other format *EXCEPT* the format distributed by
			the U.S. NTIS (which organization holds the rights
			to the distribution and use of the font data in that
			particular format). Not that anybody would really
			*want* to use their format... each point is described
			in eight bytes as "xxx yyy:", where xxx and yyy are
			the coordinate values as ASCII numbers.

'/

Type HVFVertex
   As Integer x,y,up
End Type

Type HVFChar
   As Integer      charID
   As Integer      vertcount
   As HVFVertex Ptr vert   
   As Integer      dx,dy
   As Integer      pre,post   
End Type

Type HVFCharSet
   As Integer     charCount
   As HVFChar Ptr chars
End Type

Enum HVFONTS
   SCRIPTS 
   SCRIPTC 
   ROMANT  
   ROMANS   
   ROMANP   
   ROMANC   
   ROMANCS 
   ITALICT 
   ITALICC 
   GREEKS   
   GREEKP   
   GOTHGBT 
End Enum

Type HVFont
   
   Declare Constructor()
   Declare Constructor(font As HVFONTS)
   Declare Destructor()

Public:   
   
   Declare Function DrawString(  surface  As Any Ptr  = 0          , _
                                 x        As Integer              , _
                                 y        As Integer              , _
                                 text     As String               , _
                                 clr      As UInteger = &hFFFFFF  , _
                                 size     As Single   = 1 ) As Integer
   
   Declare Function GetFontHeight(size As Single=1)                  As Integer
   Declare Function GetFontWidth (size As Single=1)                  As Integer
   Declare Function GetCharWidth (ascii As UByte, size As Single=1)  As Integer
   Declare Function GetCharHeight(ascii As UByte, size As Single=1)  As Integer
   Declare Function SetFont      (font As HVFONTS)                   As Integer
   
Private:
   
   Declare Function ReadFontData    () As Integer
   Declare Function DrawChar        (surface As Any Ptr=0, char As Integer) As Integer
   Declare Function FindIndex       (char As Integer) As Integer
   Declare Function RenderChar      (surface As any ptr, char As Integer) As Integer
   Declare Function ReadHersheyMap  (font As HVFONTS) As Integer
   Declare Function CalculateMetrics() As Integer
      
   As HVFCharSet   charset

   As Integer  curposx, curposy
   As Integer  charmap(256)
   As Integer  indxmap(4096)
   
   As UInteger fontclr   
   As Single   fontsize
   As Integer  fontheight, fontwidth 'maximums
      
End Type

#Ifdef MAKELIB
#Include "HVFont.bas"
#Else
#Inclib "hvflib"
#EndIf
